function maxwell()
   local t = getTurn()
   if (t <= 30) then
	  changeSpeed(2+(30-t)/10)
   elseif (t > 120) then
	  changeSpeed(2+(t-120)/10)
   elseif (t == 120) then
	  changeDirectionAbs(math.pi)
   end
end
--[[
function maxwell_shot()
   maxwell()
   local t = getTurn()
   if (t == 120) then
	  blAim()
	  fire_null(1, 0)
	  blType(SHOT_LIGHT)
	  blOffset(5, 0)
	  fire(2, 0)
	  blOffset(-5, 0)
	  fire(2, 0)
   end
end
]]

function coulomb()
   local t = getTurn()
   if (t <= 30) then
	  changeSpeed((30-t)/10)
   elseif (t == 380) then
	  changeSpeed(-5)
   end
   blType(SHOT_LIGHT)
   blAbs()
   fire(1.5, math.random()*math.pi*2)
end

function poynting_init()
   blType(SHOT_LIGHT)
end
function poynting(i)
   local t = getTurn()
   if (t < 60) then
	  changeDirectionAbs(i * math.pi * 0.005 * t)
      if (math.mod(t, 30) == 29) then
		 fire(2, 0)
      end
   elseif (t < 100) then
	  changeDirectionAbs(i * math.pi * (0.65 - 0.005 * t))
   end
end

gauss_cnt = 0
function gauss_init()
   setPos(150, 100)
   blAbs()
   blType(SHOT_CORE)
--   blLife(1)
   blLife(300)
   blScore(500)
   for i = 1, 3 do
	  fire_hold(2, 2*math.pi/3*i, "gauss_child")
   end
end
function gauss()
   if (hold == 1) then
	  blClear()
	  blName("gauss_legacy")
	  blType(SHOT_CORE)
	  fire(0, 0)
	  vanish()
   end
end

function gauss_child()
   local t = getTurn()
   if (t == 30) then
	  changeDirectionAbs(getDirection()+math.pi*0.5)
   elseif (t > 30) then
	  changeDirectionAbs(getDirection()+math.pi*0.01)
	  local cnt = math.mod(t, 10)
	  if (cnt < 5) then
		 blAbs()
		 blType(SHOT_LIGHT)
		 fire(2, getDirection()-math.pi)
	  end
   end
end

function gauss_legacy_init()
   blName("gauss_legacy_fire")
   blType(SHOT_LIGHT)
   blColor(1, 0.3, 0)
   blAbs()
end
function gauss_legacy()
   local t = getTurn()
   if (t == 20) then
	  blId(0)
	  fire(3, math.pi-0.2)
   elseif (t == 40) then
	  blId(0)
	  fire(3, math.pi+0.2)
   elseif (t == 60) then
	  blId(1)
	  fire(3, math.pi)
	  vanish()
   end
end
function gauss_legacy_fire_init()
   blType(SHOT_CIRCLE)
   blAbs()
end
function gauss_legacy_fire(id)
   local t = getTurn()

   setSpeed(getSpeedX()*0.995, getSpeedY()+0.05)

   if (t > 30) then
	  fire(3, math.pi - math.random() + 0.5)

	  if (t > 120) then
		 blType(SHOT_LIGHT)
		 blColor(1, 0.7, 0.7)
		 for i = 1, 16 do
			fire(3, math.pi*i/8)
		 end
		 blColor(1, 0.8, 0.8)
		 for i = 1, 16 do
			fire(2.5, math.pi*(i+0.5)/8)
		 end
		 blColor(1, 0.9, 0.9)
		 for i = 1, 15 do
			fire(2, math.pi*i/8)
		 end

		 if (id == 1) then
			blColor(0.8, 0.8, 1)
			blType(SHOT_CORE)
			blLife(100)
			blName("gauss_ancestor")
			fire(2, 0)
		 else
			fire(2, 0)
		 end

		 vanish()
	  end
   end
end

function gauss_ancestor()
   local t = getTurn()
   if (hold == 0) then
	  vanish()
   elseif (t == 130) then
	  setSpeed(0, 0)
   elseif (t > 130 and math.mod(t, 30) == 0) then
	  blAim()
	  fire_null(1, 0)
	  blType(SHOT_LIGHT)
	  blOffset(10, 0)
	  fire(2, 0)
	  fire(2.5, 0)
	  fire(3, 0)
	  blOffset(-10, 0)
	  fire(2, 0)
	  fire(2.5, 0)
	  fire(3, 0)
   end
end

function kirchhoff_init()
   blType(SHOT_LIGHT)
end
function kirchhoff()
   local t = getGameTurn()
   if (getTurn() == 30) then
	  setSpeed(0, 0)
   end

   local c = math.mod(t, 40)
   if (c == 0) then
	  blAim()
	  if (math.mod(t, 80) < 40) then
		 fire(2, -0.2)
	  else
		 fire(2, 0.2)
	  end
	  blRel()
	  fire(2, math.pi * 2 / 3)
	  fire(2, math.pi * 2 / 3)
   elseif (c < 9 and math.mod(c, 2) == 0) then
	  if (math.mod(t, 80) < 40) then
		 fire(2+c*0.2, math.pi * 2 / 3 + 0.1)
	  else
		 fire(2+c*0.2, math.pi * 2 / 3 - 0.1)
	  end
	  fire(2+c*0.2, math.pi * 2 / 3)
	  fire(2+c*0.2, math.pi * 2 / 3)
   end
end
function kirchhoff_quit()
   hold = 1
end
