dofile("data/kk.lua")

cnt = 0
hold = 0

function fourier_init()
   blType(SHOT_LIGHT)
   blColor(0.7, 0.8, 1)
   blAim()
end

function fourier()
   setSpeed(0, getSpeedY()-0.02)
   local t = getTurn()
   if (t > 70 and t < 150 and math.mod(t, 8) == 0) then
	  fire(2+(t-70)*0.03, 0)
   end
end

function legendre_bit_init()
   blType(SHOT_CIRCLE)
   blAim()
   blColor(0.9, 0.9, 1)
end
function legendre_bit(x)
   local t = getTurn()
   if (t == 15) then
	  setSpeed(0, 0)
   elseif (t > 900) then
	  vanish()
   else
	  local c = math.mod(t, 30)
	  if (c == 16) then
		 blAim()
		 fire(3, 0)
		 blRel()
		 fire(3, 0.5)
		 fire(3, -1)
	  elseif (c > 15 and math.mod(c, 2) == 1) then
		 fire(3+(c-15)*0.1, 1)
		 fire(3+(c-15)*0.1, -0.5)
		 fire(3+(c-15)*0.1, -0.5)
	  elseif (c < 15) then
		 r = t / 20 + math.pi * x
		 setPos(150+100*math.sin(r), 100-50*math.cos(r))
	  end
   end
end
function legendre_init()
   blType(SHOT_CORE)
   blAbs()
   blLife(500)
   blHoldChild(ON)
   blName("legendre_bit")
   blId(1)
   fire(5, math.pi*0.5)
   blId(0)
   fire(5, -math.pi*0.5)

   blClear()
   blAim()
   blType(SHOT_LIGHT)
   blColor(1, 1, 0.9)
end
function legendre()
   local t = getTurn()
   if (t <= 100) then
	  setPos(150, t)
   elseif (math.mod(t, 3) == 1) then
	  for i = 0, 10 do
		 fire(3, math.pi*(i/5+0.5))
	  end
   end
end
function legendre_quit()
   hold = 0
end

function green_init()
   blType(SHOT_LIGHT)
end
function green()
   local t = getTurn()
   if (math.mod(t, 15) == 2) then
	  fire(2, math.random()*0.2-0.1)
   end
end

function lebegue_child_init()
   blAim()
end
function lebegue_child()
   local t = getTurn()
   if (t < 50) then
	  if (t == 30) then
		 setSpeed(0, 0)
	  end
   elseif (t < 70) then
	  if (t == 69) then
		 blName("null_bullet")
		 fire(1, -0.3)
		 blClear()
		 blType(SHOT_LIGHT)
		 blRel()
	  end
   elseif (t < 130) then
	  if (math.mod(t, 10) == 0) then
		 fire(2, 0.6)
		 fire(2, -0.6)
	  end
   elseif (t == 140) then
	  blAim()
	  fire(2, 0.06)
	  fire(2, 0.18)
	  fire(2, 0.30)
	  fire(2, -0.06)
	  fire(2, -0.18)
	  fire(2, -0.30)
	  vanish()
   end
end
function lebegue_init()
   blAbs()
   blType(ENEMY_POINT)
   blScore(100)
   blName("lebegue_child")
end
function lebegue()
   local t = getTurn()
   if (math.mod(t, 150) == 70) then
	  local r = math.random() * math.pi * 2
	  fire(2, r)
	  fire(2, r+math.pi*0.66667)
	  fire(2, r-math.pi*0.66667)
   end
end

function top()
   sleep(100)

   nextScene()

   blColor(0.7, 0.8, 1)
   blType(SHOT_CORE)
   blName("fourier")
   blLife(70)
   blAbs()

   for i = 1, 4 do
	  setPos(150+i*30, 0)
	  fire(3, 0)
	  setPos(150-i*30, 0)
	  fire(3, 0)
	  sleep(130)
   end

   sleep(200)

   nextScene()

   blLife(10)
   for i = 1, 10 do
	  setPos(150+i*12, 0)
	  fire(3, 0)
	  setPos(150-i*12, 0)
	  fire(3, 0)
	  sleep(30)
   end

   sleep(150)

   nextScene()

   legendre_init_turn = getGameTurn()
   hold = 1

   blType(SHOT_CORE)
   blName("legendre")
   blLife(2000)
   blScore(100)
   setPos(150, 0)
   fire(0, 0)

   while (hold == 1) do
	  sleep(10)
   end

   legendre_quit_cnt = (600 - getGameTurn() + legendre_init_turn) / 5

   nextScene()

   blScore(-1)
   blType(SHOT_CORE)
   blName("green")
   blAim()
   blColor(0.9, 1, 0.9)
   blLife(3)
   for i = 0, legendre_quit_cnt do
	  setPos(math.random()*300, 0)
	  fire(3, 0)
	  sleep(5)
   end

   sleep(200)

   nextScene()

   blType(ENEMY_BALLS)
   blName("lebegue")
   blAbs()
   blLife(300)
   blColor(0.9, 1, 1)
   setPos(0, 0)
   fire(1, math.pi*0.25)
   sleep(300)

   blType(ENEMY_BALLS)
   blName("lebegue")
   blAbs()
   blLife(300)
   setPos(300, 0)
   blColor(0.9, 1, 1)
   fire(1, -math.pi*0.25)
   sleep(360)

   blType(ENEMY_BALLS)
   blName("lebegue")
   blAbs()
   blLife(300)
   blColor(0.9, 1, 1)
   setPos(0, 0)
   fire(1, math.pi*0.25)
   sleep(200)

   blType(SHOT_CORE)
   blName("green")
   blAim()
   blColor(0.9, 1, 0.9)
   blLife(3)
   for i = 0, 10 do
	  setPos(300, 0)
	  fire(3, 0)
	  sleep(10)
   end

   blType(ENEMY_BALLS)
   blName("lebegue")
   blAbs()
   blLife(300)
   blColor(0.9, 1, 1)
   setPos(0, 0)
   fire(1, math.pi*0.25)
   sleep(200)

   blType(SHOT_CORE)
   blName("green")
   blAim()
   blColor(0.9, 1, 0.9)
   blLife(3)
   for i = 0, 10 do
	  setPos(300, 0)
	  fire(3, 0)
	  sleep(10)
   end

   blType(ENEMY_BALLS)
   blName("lebegue")
   blAbs()
   blLife(300)
   blColor(0.9, 1, 1)
   setPos(300, 0)
   fire(1, -math.pi*0.25)
   sleep(200)

   blType(SHOT_CORE)
   blName("green")
   blAim()
   blColor(0.9, 1, 0.9)
   blLife(3)
   for i = 0, 10 do
	  setPos(0, 0)
	  fire(3, 0)
	  sleep(10)
   end

   sleep(300)

   stageEnd()
   sleep(1)
end

