private import type;
private import shot;
private import game;
private import mymath;
private import bullet;
private import std.math;
private import opengl;
private import log;
private import myio;

class HomingShot : Shot {
public:
	this(float x, float y, float sx, float sy, float a, float s,
		 Type t, Game game) {
		super(x, y, sx, sy, a, s, t);
		game_ = game;

		for (int i = 0; i < PREV_NUM; i++) {
			prevX_[i] = x;
			prevY_[i] = y;
			prevA_[i] = a;
		}
		prevIte_ = 0;

		targetting();

		life_ = 20;

		dyingCnt_ = 10000;
	}

	void targetting() {
		target_ = null;
		float minAngle = 1000; // larger than std.math.PI
		foreach (Enemy b; game_.enemys()) {
			if (!b || !b.alive()) continue;
			float angle = std.math.fabs(relAngle(a_ - angle(x_, y_, b.x, b.y)));
			if (angle < minAngle) {
				minAngle = angle;
				target_ = b;
			}
		}
	}

	// @@@ property problem?
	float life() {
		return super.life();
	}

	void life(float life) {
		super.life(life);
		if (life <= 0 && type_ > 0) {
			dyingCnt_ = 30;
			type_ = (Type)(-type_);
		}
	}

	void move() {
		dyingCnt_--;

		if (!target_ || !target_.alive()) targetting();

		super.move();

		prevIte_ = (prevIte_ + 1) & 31;
		prevX_[prevIte_] = x_;
		prevY_[prevIte_] = y_;

		if (target_ === null) {
			sx_ *= 1.1;
			sy_ *= 1.1;
			return;
		}

		// from http://i-saint.abz.jp/2003.html#2003/8/7
		// vel=vel*0.93+(target-pos).normalize()*1.2;

		float dx = target_.x - x_;
		float dy = target_.y - y_;
		normalize(dx, dy);
		sx_ = sx * 0.93 + dx;
		sy_ = sy * 0.93 + dy;

		a_ = angle(sx_, sy_);
/*
		float angle = relAngle(rtod(angle(target_.x, target_.y, x_, y_)) - a_);

		if (angle > 5) a_ -= 8;
		else if (angle < -5) a_ += 8;
		else return;

		sx_ = s_ * std.math.sin(dtor(a_));
		sy_ = s_ * std.math.cos(dtor(a_));
*/

	}

	void draw() {
		for (int i = 1; i < PREV_NUM; i++) {
			glColor4f(1, 0.7, 0.7, 0.3);

			glBegin(GL_TRIANGLE_FAN);

			glVertex3f(prevX_[i], prevY_[i], 0);
			glVertex3f(prevX_[i-1]+rnd(10.0f)-5, prevY_[i-1]+rnd(10.0f)-5, 0);
			glVertex3f(prevX_[i-1]+rnd(10.0f)-5, prevY_[i-1]+rnd(10.0f)-5, 0);

			glEnd();
		}
		for (int i = 1; i < PREV_NUM; i++) {
			glColor4f(0.7, 1, 1, 0.2);

			glBegin(GL_TRIANGLE_FAN);

			glVertex3f(prevX_[i], prevY_[i], 0);
			glVertex3f(prevX_[i-1]+rnd(10.0f)-5, prevY_[i-1]+rnd(10.0f)-5, 0);
			glVertex3f(prevX_[i-1]+rnd(10.0f)-5, prevY_[i-1]+rnd(10.0f)-5, 0);

			glEnd();
		}
	}

	bit alive() {
		return dyingCnt_ > 0 && life_ > -5000;
	}

private:
	Game game_;
	
	Enemy target_;

	static const int PREV_NUM = 32;
	float[PREV_NUM] prevX_, prevY_, prevA_;
	int prevIte_;
	int deadIte_;
	int dyingCnt_;

}
