private import log;
private import myio;

class Score {
	this() {
		score_ = 0;
		sceneInit();
	}

	void add(int score) {
		score_ += score;
		sceneScore_[scene_] += score;
	}

	int val() {
		return score_;
	}

	void addEnemy() {
		sceneEnemys_[scene_]++;
	}
	void addDestroy() {
		sceneDestroys_[scene_]++;
	}
	void addShot() {
		sceneShots_[scene_]++;
	}
	void addRok() {
		sceneRoks_[scene_]++;
	}

	void sceneInit() {
		scene_ = -1;
		sceneScore_.length = 0;
		sceneEnemys_.length = 0;
		sceneDestroys_.length = 0;
		sceneShots_.length = 0;
		sceneRoks_.length = 0;
	}

	void nextScene() {
		if (scene_ != -1) {
			Log.info(
				"Scene" ~ tostr(scene_+1) ~ " closed." ~
				" Score: " ~ tostr(sceneScore_[scene_]) ~
				" DRate: " ~ tostr(getDestructionRate(scene_)) ~
				" RRate: " ~ tostr(getRokRate(scene_))
				);
		}

		scene_++;
		sceneScore_ ~= 0;
		sceneEnemys_ ~= 0;
		sceneDestroys_ ~= 0;
		sceneShots_ ~= 0;
		sceneRoks_ ~= 0;
	}

	int getSceneScore(int scene) {
		return sceneScore_[scene];
	}
	int getDestructionRate(int scene) {
		if (sceneEnemys_[scene] == 0) return 0;
		return sceneDestroys_[scene] * 100 / sceneEnemys_[scene];
	}
	int getRokRate(int scene) {
		if (sceneShots_[scene] == 0) return 0;
		return sceneRoks_[scene] * 100 / sceneShots_[scene];
	}

private:
	int score_;
	int scene_;

	int[] sceneScore_;
	int[] sceneEnemys_;
	int[] sceneDestroys_;
	int[] sceneShots_;
	int[] sceneRoks_;
}
